﻿using System;
using System.Collections.Generic;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System.IO;
using System.Text;
using System.Security.Cryptography;

namespace wanshu_api_demo
{
	/// <summary>
	/// 闪验后端服务置换手机号接口请求Demo示例
	/// </summary>
	public class FlashApiDemo
	{


	    const string CMCC_API_URL = "https://api.253.com/open/flashsdk/mobile-query-m";
	    const string CTCC_API_URL = "https://api.253.com/open/flashsdk/mobile-query-t";
	    const string CUCC_API_URL = "https://api.253.com/open/flashsdk/mobile-query-u";
	
	    public static void Main(string[] args) {
	    	string appId="zzzzzzzz";
	    	string appKey="zzzzzzzz";
	    	
	    	// 闪验sdk返回的参数
	    	IDictionary<string, string> dic = new Dictionary<string, string>();
	        dic.Add("appId", appId);
	        dic.Add("randoms", "dbfe7cff-32bf-4195-a233-c9d6d784f3b8");
			dic.Add("timestamp", "1557283379173");
			dic.Add("device", "device=HUAWEI");
			dic.Add("telecom", "CTCC");
			dic.Add("version", "2.1.2");
			dic.Add("accessToken", "90b5004b7c81454898e1fe1d9fed251d");
			dic.Add("sign", "T4BFE70V2AI/RckYwKBDSIYsIQ4=");	

	        string mobile=invokeApi(dic,appKey);
				
			Console.WriteLine("手机号:" + mobile);
			Console.ReadLine();
	    }
	
	
	    static string invokeApi(IDictionary<string, string> dic,string appKey) {
	        string mobile="";
	        
	        string url="";
	        if(dic["telecom"].Equals("CTCC")){
	        	url=CTCC_API_URL;
	        }else if(dic["telecom"].Equals("CUCC")){
	        	url=CUCC_API_URL;
	        }else if(dic["telecom"].Equals("CMCC")){
	        	url=CMCC_API_URL;
	        }
	        
	        // 1.调用置换手机号api
	        string result = HttpUtility.Post(url, dic);
	        JObject jsonObject =  string.IsNullOrEmpty(result) ? null : (JObject)JsonConvert.DeserializeObject(result);
			
	        // 2.处理返回结果
	        if (jsonObject != null) {
	            //响应code码。200000：成功，其他失败
	            string code = jsonObject["code"].ToString();
	            if ("200000".Equals(code) && null != jsonObject["data"]) {
	                // 调用成功
	                // 解析结果数据，进行业务处理
	                // 检测结果
	                Console.WriteLine("调用成功,data:" + jsonObject["data"].ToString());
	
	                string mobileName=jsonObject["data"]["mobileName"].ToString();
	                
	                //解密手机号
	                mobile=DesDecrypt(mobileName,appKey);
	                
	            } else {
	                // 记录错误日志，正式项目中请换成log打印
	                Console.WriteLine("调用失败,code:" + code + ",msg:" +  jsonObject["message"]);
	            }
	        }
	        return mobile;
	    }
	    
	    //DES解密
	    public static string DesDecrypt(string decryptString, string decryptKey)
        {
            try
            {
                //将字符转换为UTF - 8编码的字节序列
                byte[] rgbKey = Encoding.UTF8.GetBytes(decryptKey.Substring(0, 8));
                byte[] rgbIV=new byte[]{1,2,3,4,5,6,7,8};
                byte[] inputByteArray = Convert.FromBase64String(decryptString);
                //用指定的密钥和初始化向量使用CBC模式的DES解密标准解密
                DESCryptoServiceProvider dCSP = new DESCryptoServiceProvider();
                dCSP.Mode = CipherMode.CBC;
                dCSP.Padding = PaddingMode.PKCS7;
                MemoryStream mStream = new MemoryStream();
                CryptoStream cStream = new CryptoStream(mStream, dCSP.CreateDecryptor(rgbKey, rgbIV), CryptoStreamMode.Write);
                cStream.Write(inputByteArray, 0, inputByteArray.Length);
                cStream.FlushFinalBlock();
                return Encoding.UTF8.GetString(mStream.ToArray());
            }
            catch(Exception e)
            {
            	Console.WriteLine(e);
            	return "";
            }
        }
	}
}
